import numpy as np
import re
import random
from numpy.random import choice, permutation

class BatchGenerator():
	def __init__(self, datas, labels,num_feat,sample_num):
		np.random.seed(0)  # 每次随机数一致
		random.seed(0)
		self.labels = labels
		self.datas = datas.reshape((sample_num,num_feat,1))
		self.tot = len(labels)  # 训练集标签个数
		self.num_idx = dict()
		#num_idx={类别：[索引数组]例   1：[2,43,54,76,87...],...}
		for idx, num in enumerate(self.labels):
			if num in self.num_idx:
				self.num_idx[num].append(idx)
			else:
				self.num_idx[num] = [idx]
		self.to_data = lambda x: self.datas[x]

	def next_batch(self,batch_size):
		left = []
		right = []
		sim = []
		for i in range(self.tot):
			for j in range(i + 1, self.tot):
				left.append(self.to_data(i))
				right.append(self.to_data(j))
				if self.labels[i] == self.labels[j]:
					sim.append([0])
				else:
					sim.append([1])
		return np.array(left), np.array(right), np.array(sim)

# read the training/validation/testing set
def get_data(filename):
	label = []
	data = []
	f = open(filename)
	line = f.readline()
	while line:
		label.append(int(line[0]))
		a = re.split(',', line[2:])
		a = [float(i) for i in a]
		data.append(a)
		line = f.readline()
	f.close()
	data = np.array(data)
	label = np.array(label)
	return data, label
