import tensorflow  as tf
import numpy as np
import tensorflow.contrib.slim as slim
from dataset import BatchGenerator,get_data
from model import *
import sys
import shutil
from public.Accuracy_fun import *
np.seterr(divide='ignore', invalid='ignore')

flags = tf.app.flags
FLAGS = flags.FLAGS
flags.DEFINE_integer('batch_size', 60, 'Batch size.')
flags.DEFINE_integer('train_iter', 2, 'Total training iter')

if __name__ == "__main__":
	train_file = sys.argv[1]  #the path of training set
	test_file = sys.argv[2]   #the path of test set
	# train_file ="data/TRAIN.txt"
	# test_file = "data/TEST.txt"

	test_acc = 0
	Sn = 0
	Sp = 0
	num =0
	epoch =0
	#load dataset
	train_data,train_label = get_data(train_file)
	k =len(train_data[0])
	train_num = len(train_label)
	gen = BatchGenerator(train_data, train_label,k,train_num)

	left = tf.placeholder(tf.float32, [None, k,1], name='left')
	right = tf.placeholder(tf.float32, [None, k,1], name='right')

	with tf.name_scope("similarity"):
		label = tf.placeholder(tf.int32, [None, 1], name='label') # 1 if same, 0 if different
		label = tf.to_float(label)
	margin = 1

	left_output = mynet(left, reuse=False)
	right_output = mynet(right,reuse=True)
	loss = contrastive_loss(left_output, right_output, label, margin)

	global_step = tf.Variable(0, trainable=False)
	train_step = tf.train.AdagradOptimizer(0.001).minimize(loss)

	saver = tf.train.Saver()
	with tf.Session() as sess:
		sess.run(tf.global_variables_initializer())
		# train iter
		for i in range(FLAGS.train_iter):
			b_l, b_r, b_sim = gen.next_batch(FLAGS.batch_size)
			_, l= sess.run([train_step, loss], feed_dict={left: b_l, right: b_r, label: b_sim})
			print("\r#%d - Loss" % i, l)
			saver.save(sess, "temp_model/model.ckpt")

			# calculate the performance measurements
			temp_acc,temp_Sn,temp_Sp,temp_num= Accuracy(test_file)
			if test_acc<temp_acc:
				test_acc = temp_acc
				Sn = temp_Sn
				Sp = temp_Sp
				num = temp_num
				epoch = i+1
				saver.save(sess, "model/model.ckpt")
	print("The final classification resultes are:")
	print("Accuracy =",test_acc,"Sn =",Sn,"Sp =",Sp)
	print("the feature number of IFS with best performance: ",num)
	print("The trained model was saved on file folder \'model\' ")

	shutil.rmtree("temp_model",True)
